#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <ogcsys.h>
#include <gccore.h>
#include <wiiuse/wpad.h>
#include <zlib.h>
#include <fat.h>
#include <mxml.h>

static u32 *xfb;
static GXRModeObj *rmode;

void Initialise() {

	VIDEO_Init();
	WPAD_Init();

	fatInitDefault();//Se inicializa el sistema de ficheros
	rmode = VIDEO_GetPreferredMode(NULL);

	xfb = MEM_K0_TO_K1(SYS_AllocateFramebuffer(rmode));
	console_init(xfb,20,20,rmode->fbWidth,rmode->xfbHeight,rmode->fbWidth*VI_DISPLAY_PIX_SZ);

	VIDEO_Configure(rmode);
	VIDEO_SetNextFramebuffer(xfb);
	VIDEO_SetBlack(FALSE);
	VIDEO_Flush();
	VIDEO_WaitVSync();
	if(rmode->viTVMode&VI_NON_INTERLACE) VIDEO_WaitVSync();

}


int main() {

	Initialise();
	printf("\x1b[2;0H");

	printf("Ejemplo 3\n");
	printf("Se ha creado un fichero 'documento.xml' en la raiz de la SD.\n Pulsa HOME para salir\n");

	while(1) {

		WPAD_ScanPads();
		u32 pressed = WPAD_ButtonsDown(0);

        mxml_node_t *raiz_xml;//Nodo raiz
        mxml_node_t *padre;//Nodo para el elemento padre
        mxml_node_t *hijo;//Nodo para el elemento hijo

        raiz_xml = mxmlNewXML("1.0");//Se crea el nuevo documento xml y se almacena en el nodo raiz

        padre = mxmlNewElement(raiz_xml, "padre");//Se crea el elemento "padre"
        mxmlElementSetAttr(padre, "atributo", "valor_atributo");//Se crea un atributo de nombre "atributo" para el elemento "padre", con valor "valor_atributo"
        hijo = mxmlNewElement(padre, "hijo");//Se crea un elemento "hijo", que colgar del elemento almacenado en el nodo padre
        mxmlNewText(hijo, 0, "Texto del hijo");//Se aade texto al elemento almacenado en el nodo hijo

        FILE  *f;
        f = fopen("sd:/documento.xml", "wb");//Se crea un fichero "documento.xml" en la raiz de la SD. Si ya existe, se sobreescribe
        mxmlSaveFile(raiz_xml, f, MXML_NO_CALLBACK);//Se almacena el nodo raiz, que contiene todo el documento xml, en el fichero



		if (pressed & WPAD_BUTTON_HOME) {
			exit(0);
		}

		VIDEO_WaitVSync();
	}

	return 0;
}
