#include <stdio.h>
#include <stdlib.h>
#include <gccore.h>
#include <wiiuse/wpad.h>
#include <fat.h>

#include <wiisprite.h>
#include "libwiisprite.h"

using namespace wsp;



GameWindow gwd; // Inicializa y renderiza la escena.
Sprite sprite; // El objeto que podemos modificar.
Sprite sprite2; // Otro objeto que podemos modificar.
Quad quad; // Un rectngulo para crear un efecto de fade in y fade out.
Image image; // Almacena la imagen de la tarjeta SD.
Image image2; // Almacena la imagen contenida en un buffer.



bool calc_fade(u8 fade);//Funcion para el efecto de fade in y fade out
u8 fadedata = 0xff;

int main(int argc, char **argv) {
	fatInitDefault();//Se inicializa el sistema de archivos, necesario para cargar imgenes desde la SD.

	gwd.InitVideo();

	LayerManager manager(3);//LayerManager de 3 capas

	if(image.LoadImage("libwiisprite.png") != IMG_LOAD_ERROR_NONE)exit(0);//Se carga la imagen desde la SD
	if(image2.LoadImage(libwiisprite) != IMG_LOAD_ERROR_NONE)exit(0);//Se carga la imagen desde el buffer


    //Se asigna cada imagen a un sprite
	sprite.SetImage(&image);
	sprite2.SetImage(&image2);

	sprite.SetPosition(0, 0);

    //El sprite2 se dibujar alrededor del pxel central de la pantalla
	sprite2.SetRefPixelPositioning(REFPIXEL_POS_PIXEL);
	sprite2.SetPosition(gwd.GetWidth()/2, gwd.GetHeight()/2);

    //Se crea el objeto quad algo ms grande que el resto de la pantalla
	quad.SetPosition(-40, -40);
	quad.SetWidth(800);
	quad.SetHeight(600);


    //Se asigna cada objeto que se va a renderizar en una capa del manager
	manager.Append(&quad);
	manager.Append(&sprite);
	manager.Append(&sprite2);

	WPAD_Init();
	WPAD_SetDataFormat(WPAD_CHAN_0, WPAD_FMT_BTNS_ACC_IR);

	u8 fading = 1; //Se inicia el efecto de fade in
	while(1) {

		WPAD_ScanPads();
		u32 pressed = WPAD_ButtonsHeld(WPAD_CHAN_0);

        //El boton Home inicia el efecto de fade out
		if(pressed & WPAD_BUTTON_HOME)fading = 2;

		if(calc_fade(fading))break;//Si la funcion calc_fade devuelve true, la aplicacin termina
		if(fadedata == 0x00)fading = 0;

        //Los botones + y - del wiimote escalan la imagen del puntero
		if(pressed & WPAD_BUTTON_MINUS)
			sprite.SetZoom(sprite.GetZoom()-0.1f);
		if(pressed & WPAD_BUTTON_PLUS)
			sprite.SetZoom(sprite.GetZoom()+0.1f);

        //Los botones A y B aumentan o disminuyen la visibilidad de la imagen del puntero, respectivamente
		if(pressed & WPAD_BUTTON_A && sprite.GetTransparency() < 0xff-4)
			sprite.SetTransparency(sprite.GetTransparency()+5);
		if(pressed & WPAD_BUTTON_B && sprite.GetTransparency() > 4){
			sprite.SetTransparency(sprite.GetTransparency()-5);
		}

        //Con el pad direccional se escala la imagen central en ejes separados
		if(pressed & WPAD_BUTTON_UP)
			sprite2.SetStretchHeight(sprite2.GetStretchHeight()+0.1f);
		if(pressed & WPAD_BUTTON_DOWN)
			sprite2.SetStretchHeight(sprite2.GetStretchHeight()-0.1f);
		if(pressed & WPAD_BUTTON_RIGHT)
			sprite2.SetStretchWidth(sprite2.GetStretchWidth()+0.1f);
		if(pressed & WPAD_BUTTON_LEFT)
			sprite2.SetStretchWidth(sprite2.GetStretchWidth()-0.1f);

        //funciones para usar la imagen asignada a sprite como puntero del wiimote
		ir_t ir;
		WPAD_IR(WPAD_CHAN_0, &ir);
		sprite.SetPosition(ir.sx-WSP_POINTER_CORRECTION_X, ir.sy-WSP_POINTER_CORRECTION_Y);
		sprite.Move(-((f32)sprite.GetWidth()/2), -((f32)sprite.GetHeight()/2));
		sprite.SetRotation(ir.angle/2);

        //Dibuja todos los objetos del manager
		manager.Draw(0,0);

		gwd.Flush();
	}

	manager.Draw(0,0);
	gwd.Flush();

	return 0;
}

bool calc_fade(u8 fade){

	if(fade == 1){ // Fading in
		if(fadedata < 0x10)fadedata = 0x10;
		fadedata -= 0x10;
	}else if(fade == 2){ //Fading out
		if(0xef < fadedata)fadedata = 0xef;
		fadedata += 0x10;
	}

	quad.SetFillColor((GXColor){0x00, 0x00, 0x00, fadedata});

	if(fade == 2 && fadedata == 0xff)return true;

	return false;
}
