#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <gccore.h>
#include <wiiuse/wpad.h>
#include <fat.h>
#include <time.h>
#include <mxml.h>

#include <asndlib.h>
#include <mp3player.h>
#include <wiisprite.h>

#include "puntero_png.h"
#include "diana_png.h"
#include "panel_png.h"
#include "puntero2_png.h"
#include "shoot.h"

using namespace wsp;

static void *xfb = NULL;
static GXRModeObj *rmode = NULL;

GameWindow gwd;

//GameWindow gwd; // Initializes and renders our scene.
Sprite jugador1; // The drawable object we can modify.
Sprite jugador2;
Sprite diana; // Another drawable object we can modify.

Image image;
Image image2;
Image image3;
Image image4;
u32 width, height, dWidth, dHeight;

int puntuacion1 = 0;
int puntuacion2 = 0;

void new_position();

void inicializa(){
	VIDEO_Init();

	fatInitDefault();

	WPAD_Init();

	ASND_Init();

	MP3Player_Init();

	rmode = VIDEO_GetPreferredMode(NULL);

	xfb = MEM_K0_TO_K1(SYS_AllocateFramebuffer(rmode));

	console_init(xfb,20,20,rmode->fbWidth,rmode->xfbHeight,rmode->fbWidth*VI_DISPLAY_PIX_SZ);

	VIDEO_Configure(rmode);

	VIDEO_SetNextFramebuffer(xfb);

	VIDEO_SetBlack(FALSE);

	VIDEO_Flush();

	VIDEO_WaitVSync();
	if(rmode->viTVMode&VI_NON_INTERLACE) VIDEO_WaitVSync();

}

void limpiar(void){
	console_init(xfb,20,20,rmode->fbWidth,rmode->xfbHeight,rmode->fbWidth*VI_DISPLAY_PIX_SZ);
}

void new_position(){
    if(MP3Player_IsPlaying()) MP3Player_Stop();

    MP3Player_PlayBuffer(shoot, shoot_size, NULL);

    srand(time(NULL));

    diana.SetPosition(rand()%(width-dWidth)+1, rand()%(height-dHeight)+1);
}

void juego(){

    if(!gwd.IsInitialized())
    gwd.InitVideo();

    gwd.Flush();

	width=gwd.GetWidth(); height=gwd.GetHeight();

	LayerManager manager(4);//3

	if(image.LoadImage(puntero_png) != IMG_LOAD_ERROR_NONE)exit(0);
	if(image2.LoadImage(diana_png) != IMG_LOAD_ERROR_NONE)exit(0);
    if(image3.LoadImage(panel_png) != IMG_LOAD_ERROR_NONE)exit(0);
    if(image4.LoadImage(puntero2_png) != IMG_LOAD_ERROR_NONE)exit(0);

	jugador1.SetImage(&image);
	jugador2.SetImage(&image4);
	diana.SetImage(&image2);

	TiledLayer panel(1,1,1);
	panel.SetStaticTileset(&image3,200,100);
	panel.SetPosition((width/2)-100,0);
	int indice = panel.CreateAnimatedTile();
	panel.SetCell(0,0,indice);
	panel.SetAnimatedTile(indice,3);

	jugador1.SetPosition(0, 0);
	jugador2.SetPosition(0,0);

    dWidth = diana.GetWidth();
    dHeight = diana.GetHeight();

    diana.SetPosition( (width/2)-(dWidth/2), (height/2)-(dHeight/2));

	manager.Append(&jugador1);
	manager.Append(&jugador2);
	manager.Append(&diana);
	manager.Append(&panel);


	WPAD_Init();
	WPAD_SetDataFormat(WPAD_CHAN_ALL, WPAD_FMT_BTNS_ACC_IR);
	WPAD_SetVRes(WPAD_CHAN_ALL, width, height);

	ir_t ir, ir2;
	while(1) {

		WPAD_ScanPads();
		u32 pressed = WPAD_ButtonsDown(WPAD_CHAN_0);

		if(pressed & WPAD_BUTTON_HOME)break;

		if(puntuacion1>puntuacion2){
		    panel.SetAnimatedTile(indice, 1);
		} else{
		    if(puntuacion2>puntuacion1){
		        panel.SetAnimatedTile(indice, 2);
		    }else{
		        panel.SetAnimatedTile(indice, 3);
		    }
		}

        //puntero jugador 1
		WPAD_IR(WPAD_CHAN_0, &ir);
		jugador1.SetPosition(ir.sx-WSP_POINTER_CORRECTION_X, ir.sy-WSP_POINTER_CORRECTION_Y);
		jugador1.Move(-((f32)jugador1.GetWidth()/2), -((f32)jugador1.GetHeight()/2));
		jugador1.SetRotation(ir.angle/2);

		//puntero jugador 2
		WPAD_IR(WPAD_CHAN_1, &ir2);
		jugador2.SetPosition(ir2.sx-WSP_POINTER_CORRECTION_X, ir2.sy-WSP_POINTER_CORRECTION_Y);
		jugador2.Move(-((f32)jugador2.GetWidth()/2), -((f32)jugador2.GetHeight()/2));
		jugador2.SetRotation(ir2.angle/2);

		if(jugador1.CollidesWith(&diana) && pressed & WPAD_BUTTON_B){
		    WPAD_Rumble(0,1);
		    new_position();

		    puntuacion1++;
		}
		if(jugador2.CollidesWith(&diana) && WPAD_ButtonsDown(1) & WPAD_BUTTON_B){
		    WPAD_Rumble(1,1);
		    new_position();

		    puntuacion2++;
		}
        if(WPAD_ButtonsUp(0) || WPAD_ButtonsHeld(0) ) WPAD_Rumble(0,0);
        if(WPAD_ButtonsUp(1) || WPAD_ButtonsHeld(0) ) WPAD_Rumble(1,0);

		manager.Draw(0,0);

		gwd.Flush();
	}

	manager.Draw(0,0);
	gwd.Flush();

}

void imprimir_texto(){
    printf("\n\n\n\n#########  SHOOTING GAME #########\n\n\n\n");
        printf("Puntuacion del jugador 1 : %d\n", puntuacion1);
        printf("Puntuacion del jugador 2 : %d\n\n", puntuacion2);
        printf("Pulsa A para comenzar.\n");
        printf("Pulsa 1 para cargar puntuaciones.\n");
        printf("Pulsa + para guardar puntuaciones.\n");
        printf("Pulsa - para resetear puntuaciones.\n");
        printf("Pulsa HOME para salir.\n");
}

void cargar_puntuacion(){
    mxml_node_t *raiz;
	mxml_node_t *elemento;

	FILE *fp = fopen("puntuacion.xml", "rb");

	if(fp == NULL){
	    fclose(fp);
	}
	else {
	    fseek(fp , 0, SEEK_END);
		long tamanyo_xml = ftell(fp);
		rewind(fp);
		if(tamanyo_xml > 0){
		    raiz = mxmlLoadFile(NULL, fp, MXML_NO_CALLBACK);
			fclose(fp);
			elemento = mxmlFindElement(raiz, raiz, "jugador1", NULL, NULL, MXML_DESCEND);
			if(elemento!=NULL){
			    puntuacion1 = atoi(mxmlElementGetAttr(elemento,"puntuacion"));
			}
			elemento = mxmlFindElement(raiz, raiz, "jugador2", NULL, NULL, MXML_DESCEND);
			if(elemento!=NULL){
			    puntuacion2 = atoi(mxmlElementGetAttr(elemento,"puntuacion"));
			}
			fclose(fp);
			mxmlDelete(elemento);
			mxmlDelete(raiz);
		}
		else{
		    fclose(fp);
		}
	}
}

void guardar_puntuacion(){
    mxml_node_t *raiz;
	mxml_node_t *elemento;

    raiz = mxmlNewXML("1.0");

    char punt[4];

    elemento = mxmlNewElement(raiz, "jugador1");
    sprintf(punt,"%d",puntuacion1);

    mxmlElementSetAttr(elemento,"puntuacion",punt);

    elemento = mxmlNewElement(raiz, "jugador2");
    sprintf(punt,"%d", puntuacion2);

    mxmlElementSetAttr(elemento, "puntuacion", punt);

    FILE *f;
    f = fopen("puntuacion.xml", "wb");

    if (f == NULL) {
		fclose(f);
	}
	else {
		mxmlSaveFile(raiz, f, MXML_NO_CALLBACK);
		fclose(f);
		mxmlDelete(elemento);
		mxmlDelete(raiz);
	}
}



int modoConsola(){

    limpiar();

    imprimir_texto();


    while(1){

        WPAD_ScanPads();
        u32 pressed = WPAD_ButtonsDown(0);

        if(pressed & WPAD_BUTTON_A) break;

        if(pressed & WPAD_BUTTON_HOME) exit(0);

        if(pressed & WPAD_BUTTON_1){
            limpiar();

            imprimir_texto();
            cargar_puntuacion();
        }

        if(pressed & WPAD_BUTTON_PLUS){
            guardar_puntuacion();
        }
        if(pressed & WPAD_BUTTON_MINUS){
            puntuacion1=0;
            puntuacion2=0;
            guardar_puntuacion();
            limpiar();
            imprimir_texto();
            cargar_puntuacion();
        }

        VIDEO_WaitVSync();

    }
    return 1;
}


int main(int argc, char **argv) {

    while(1){
        inicializa();
        modoConsola();
        limpiar();
        juego();
    }
    return 0;
}




