#include <stdio.h>
#include <stdlib.h>
#include <gccore.h>
#include <wiiuse/wpad.h>
#include <fat.h>
#include <time.h>

#include <asndlib.h>
#include <mp3player.h>
#include <wiisprite.h>

using namespace wsp;

GameWindow gwd;
//Sprites para el fondo y el puntero
Sprite fondo;
Sprite puntero;
Sprite fin;
//Estos quads formarn los botones
Quad quad1;
Quad quad2;
Quad quad3;
Quad quad4;
//Estos quads se usarn para indicar los intentos restantes.
Quad vida1;
Quad vida2;
Quad vida3;
//Se definen e inicializan los botones. Se indica la clave sealada por el boton (1-3), si es correcto, y si ya aparece en algn botn.
struct boton{
    int clave;//1=rojo, 2=verde, 3=azul
    int correcto;
    int encontrado;
};
struct boton boton1={0,0,0};
struct boton boton2={0,0,0};
struct boton boton3={0,0,0};
struct boton boton4={0,0,0};
//Claves a adivinar
int clave1, clave2, clave3, clave4;
//Funcion que genera claves nuevas de forma aleatoria
void nueva_clave(){
    srand(time(NULL));
    clave1=rand()%3+1;
    clave2=rand()%3+1;
    clave3=rand()%3+1;
    clave4=rand()%3+1;
}
//Inicia un nuevo juego
void nuevo_juego(){
        boton1.correcto=0; boton1.encontrado=0;
        quad1.SetFillColor((GXColor){0,0,0,255});
        quad1.SetBorderColor((GXColor){255,255,255,255});

        boton2.correcto=0; boton2.encontrado=0;
        quad2.SetFillColor((GXColor){0,0,0,255});
        quad2.SetBorderColor((GXColor){255,255,255,255});

        boton3.correcto=0; boton3.encontrado=0;
        quad3.SetFillColor((GXColor){0,0,0,255});
        quad3.SetBorderColor((GXColor){255,255,255,255});

        boton4.correcto=0; boton4.encontrado=0;
        quad4.SetFillColor((GXColor){0,0,0,255});
        quad4.SetBorderColor((GXColor){255,255,255,255});
}

int main(int argc, char **argv){

    gwd.InitVideo();

    WPAD_Init();

    fatInitDefault();

int width = gwd.GetWidth();
int height = gwd.GetHeight();

WPAD_SetDataFormat(0, WPAD_FMT_BTNS_ACC_IR);
WPAD_SetVRes(0, width, height);

Image imagen;
Image imagen2;
Image imagen3;
Image imagen4;
if(imagen.LoadImage("fondo.png") != IMG_LOAD_ERROR_NONE)exit(0);
if(imagen2.LoadImage("cursor.png") != IMG_LOAD_ERROR_NONE)exit(0);
if(imagen3.LoadImage("fondo2.png") != IMG_LOAD_ERROR_NONE)exit(0);
if(imagen4.LoadImage("nuevojuego.png") != IMG_LOAD_ERROR_NONE)exit(0);

fondo.SetImage(&imagen);
fondo.SetRefPixelPositioning(REFPIXEL_POS_PIXEL);
fondo.SetPosition(width/2, height/2);
puntero.SetImage(&imagen2);
fin.SetImage(&imagen4);//Esta imagen se mostrar si se fallan los 3 intentos
fin.SetRefPixelPositioning(REFPIXEL_POS_PIXEL);
fin.SetPosition(width/2, height/2);
fin.SetVisible(false);

//se crean los rectngulos de colisin y se dibujan los quads para los botones
Rectangle rect1, rect2, rect3, rect4;
rect1.x=width/2-250; rect1.y=height/2+100; rect1.width=50; rect1.height=50;
rect2.x=width/2-100; rect2.y=height/2+100; rect2.width=50; rect2.height=50;
rect3.x=width/2+50; rect3.y=height/2+100; rect3.width=50; rect3.height=50;
rect4.x=width/2+200; rect4.y=height/2+100; rect4.width=50; rect4.height=50;

quad1.SetRectangle(&rect1); quad2.SetRectangle(&rect2); quad3.SetRectangle(&rect3); quad4.SetRectangle(&rect4);
quad1.SetBorderWidth(50); quad1.SetBorderColor((GXColor){255,255,255,255}); quad1.SetBorder(true);
quad2.SetBorderWidth(50); quad2.SetBorderColor((GXColor){255,255,255,255}); quad2.SetBorder(true);
quad3.SetBorderWidth(50); quad3.SetBorderColor((GXColor){255,255,255,255}); quad3.SetBorder(true);
quad4.SetBorderWidth(50); quad4.SetBorderColor((GXColor){255,255,255,255}); quad4.SetBorder(true);
//Se crean los rectngulos que indican el nmero de intentos restantes
vida1.SetWidth(30); vida1.SetHeight(30); vida1.SetFillColor((GXColor){255,0,0,255}); vida1.SetPosition(width/2-65,(height/2)-210);
vida2.SetWidth(30); vida2.SetHeight(30); vida2.SetFillColor((GXColor){255,0,0,255}); vida2.SetPosition(width/2-15,(height/2)-210);
vida3.SetWidth(30); vida3.SetHeight(30); vida3.SetFillColor((GXColor){255,0,0,255}); vida3.SetPosition(width/2+35,(height/2)-210);
//manager contiene la escena principal y vidas contiene los rectngulos con los intentos restantes
LayerManager manager(7);
LayerManager vidas(3);

manager.Append(&puntero);
manager.Append(&fin);
manager.Append(&quad1);
manager.Append(&quad2);
manager.Append(&quad3);
manager.Append(&quad4);
manager.Append(&fondo);

vidas.Append(&vida1);
vidas.Append(&vida2);
vidas.Append(&vida3);

nueva_clave();
int terminar = 0;
int intentos = 3;
ir_t ir;
while(1){

    WPAD_ScanPads();
    int pressed = WPAD_ButtonsDown(0);
    if(pressed & WPAD_BUTTON_HOME) exit(0);

    WPAD_IR(WPAD_CHAN_0, &ir);
    puntero.SetPosition(ir.sx-WSP_POINTER_CORRECTION_X, ir.sy-WSP_POINTER_CORRECTION_Y);
    puntero.Move(-((f32)puntero.GetWidth()/2), -((f32)puntero.GetHeight()/2));
    puntero.SetRotation(ir.angle/2);
//Se cambian los colores de los botones mediante la interaccion del wiimote. Izquierda=rojo, abajo=verde, derecha=azul.
    if(puntero.CollidesWith(&rect1)){
        if(pressed & WPAD_BUTTON_LEFT){
            quad1.SetFillColor((GXColor){255,0,0,255});
            boton1.clave=1;
        }
        if(pressed & WPAD_BUTTON_DOWN){
            quad1.SetFillColor((GXColor){0,255,0,255});
            boton1.clave=2;
        }
        if(pressed & WPAD_BUTTON_RIGHT){
            quad1.SetFillColor((GXColor){0,0,255,255});
            boton1.clave=3;
        }
    }

    if(puntero.CollidesWith(&rect2)){
        if(pressed & WPAD_BUTTON_LEFT){
            quad2.SetFillColor((GXColor){255,0,0,255});
            boton2.clave=1;
        }
        if(pressed & WPAD_BUTTON_DOWN){
            quad2.SetFillColor((GXColor){0,255,0,255});
            boton2.clave=2;
        }
        if(pressed & WPAD_BUTTON_RIGHT){
            quad2.SetFillColor((GXColor){0,0,255,255});
            boton2.clave=3;
        }
    }

    if(puntero.CollidesWith(&rect3)){
        if(pressed & WPAD_BUTTON_LEFT){
            quad3.SetFillColor((GXColor){255,0,0,255});
            boton3.clave=1;
        }
        if(pressed & WPAD_BUTTON_DOWN){
            quad3.SetFillColor((GXColor){0,255,0,255});
            boton3.clave=2;
        }
        if(pressed & WPAD_BUTTON_RIGHT){
            quad3.SetFillColor((GXColor){0,0,255,255});
            boton3.clave=3;
        }
    }

    if(puntero.CollidesWith(&rect4)){
        if(pressed & WPAD_BUTTON_LEFT){
            quad4.SetFillColor((GXColor){255,0,0,255});
            boton4.clave=1;
        }
        if(pressed & WPAD_BUTTON_DOWN){
            quad4.SetFillColor((GXColor){0,255,0,255});
            boton4.clave=2;
        }
        if(pressed & WPAD_BUTTON_RIGHT){
            quad4.SetFillColor((GXColor){0,0,255,255});
            boton4.clave=3;
        }
    }
//Se ocultan los cuadros que indican el nmero de intentos restantes segn el valor de la variable intentos
    switch(intentos){
        case 1:
            vida3.SetVisible(false);
            vida2.SetVisible(false);
            vida1.SetVisible(true);
            break;
        case 2:
            vida3.SetVisible(false);
            vida2.SetVisible(true);
            vida1.SetVisible(true);
            break;
        case 3:
            vida3.SetVisible(true);
            vida2.SetVisible(true);
            vida1.SetVisible(true);
            break;
        case 0:
            vida1.SetVisible(false);
            vida2.SetVisible(false);
            vida3.SetVisible(false);
            terminar = 1;
            fin.SetVisible(true);
            break;
    }
//Mientras no termine el juego se comprueba el estado de los botones y si coinciden con la clave
    if(!terminar && pressed & WPAD_BUTTON_A){
        if(boton1.clave==clave1){
            boton1.correcto=1;
            boton1.encontrado=1;
            quad1.SetBorderColor((GXColor){0,255,0,255});
        }
        if(boton2.clave==clave2){
            boton2.correcto=1;
            boton2.encontrado=1;
            quad2.SetBorderColor((GXColor){0,255,0,255});
        }
        if(boton3.clave==clave3){
            boton3.correcto=1;
            boton3.encontrado=1;
            quad3.SetBorderColor((GXColor){0,255,0,255});
        }
        if(boton4.clave==clave4){
            boton4.correcto=1;
            boton4.encontrado=1;
            quad4.SetBorderColor((GXColor){0,255,0,255});
        }
        //comprobaciones boton1
        if(boton1.correcto){

        }
        else{
            if((boton1.clave==clave2) & !boton2.correcto & !boton2.encontrado){
                boton2.encontrado=1;
                quad1.SetBorderColor((GXColor){255,255,0,255});
            }
            else{
                if((boton1.clave==clave3) & !boton3.correcto & !boton3.encontrado){
                    boton3.encontrado=1;
                    quad1.SetBorderColor((GXColor){255,255,0,255});
                }
                else{
                    if((boton1.clave==clave4) & !boton4.correcto & !boton4.encontrado){
                        boton4.encontrado=1;
                        quad1.SetBorderColor((GXColor){255,255,0,255});
                    }
                    else quad1.SetBorderColor((GXColor){255,0,0,255});
                }
            }
        }

        //Comprobaciones boton2
        if(boton2.correcto){
        }
        else{
            if((boton2.clave==clave1) & !boton1.correcto & !boton1.encontrado){
                boton1.encontrado=1;
                quad2.SetBorderColor((GXColor){255,255,0,255});
            }
            else{
                if((boton2.clave==clave3) & !boton3.correcto & !boton3.encontrado){
                    boton3.encontrado=1;
                    quad2.SetBorderColor((GXColor){255,255,0,255});
                }
                else{
                    if((boton1.clave==clave4) & !boton4.correcto & !boton4.encontrado){
                        boton4.encontrado=1;
                        quad2.SetBorderColor((GXColor){255,255,0,255});
                    }
                    else quad2.SetBorderColor((GXColor){255,0,0,255});
                }
            }
        }

        //Comprobaciones boton3
        if(boton3.correcto){
        }
        else{
            if((boton3.clave==clave2) & !boton2.correcto & !boton2.encontrado){
                boton2.encontrado=1;
                quad3.SetBorderColor((GXColor){255,255,0,255});
            }
            else{
                if((boton3.clave==clave1) & !boton1.correcto & !boton1.encontrado){
                    boton1.encontrado=1;
                    quad3.SetBorderColor((GXColor){255,255,0,255});
                }
                else{
                    if((boton3.clave==clave4) & !boton4.correcto & !boton4.encontrado){
                        boton4.encontrado=1;
                        quad3.SetBorderColor((GXColor){255,255,0,255});
                    }
                    else quad3.SetBorderColor((GXColor){255,0,0,255});
                }
            }
        }

        //Comprobaciones boton4
        if(boton4.correcto){

        }
        else{
            if((boton4.clave==clave2) & !boton2.correcto & !boton2.encontrado){
                boton2.encontrado=1;
                quad4.SetBorderColor((GXColor){255,255,0,255});
            }
            else{
                if((boton4.clave==clave3) & !boton3.correcto & !boton3.encontrado){
                    boton3.encontrado=1;
                    quad4.SetBorderColor((GXColor){255,255,0,255});
                }
                else{
                    if((boton4.clave==clave1) & !boton1.correcto & !boton1.encontrado){
                        boton1.encontrado=1;
                        quad4.SetBorderColor((GXColor){255,255,0,255});
                    }
                    else quad4.SetBorderColor((GXColor){255,0,0,255});
                }
            }
        }
//si es todo correcto, el programa finaliza con exito, se cambia la imagen de fondo.
        if(boton1.correcto & boton2.correcto & boton3.correcto & boton4.correcto){
            fondo.SetImage(&imagen3);
            terminar=1;
        }else{
        intentos--;//si no, se resta un intento
        }
        boton1.encontrado=0; boton3.encontrado=0; boton2.encontrado=0; boton4.encontrado=0;
    }

//una vez finalizado el juego, puede reiniciarse pulsando B
    if(terminar && pressed & WPAD_BUTTON_B){
        nuevo_juego();

        nueva_clave();

        intentos = 3;
        terminar = 0;
        fondo.SetImage(&imagen);
        fin.SetVisible(false);
    }


    vidas.Draw(0,0);
    manager.Draw(0,0);


    gwd.Flush();

}
 vidas.Draw(0,0);
 manager.Draw(0,0);


    gwd.Flush();
return 0;




}









