#include <stdio.h>
#include <stdlib.h>
#include <gccore.h>
#include <wiiuse/wpad.h>
#include <asndlib.h>
#include <gcmodplay.h>
#include "technique_mod.h"

static void *xfb = NULL;
static GXRModeObj *rmode = NULL;

static MODPlay play;

//---------------------------------------------------------------------------------
int main(int argc, char **argv) {
//---------------------------------------------------------------------------------

	VIDEO_Init();
	WPAD_Init();
	ASND_Init();

    WPAD_SetDataFormat(0, WPAD_FMT_BTNS);

	rmode = VIDEO_GetPreferredMode(NULL);

	xfb = MEM_K0_TO_K1(SYS_AllocateFramebuffer(rmode));
	console_init(xfb,0,0,rmode->fbWidth,rmode->xfbHeight,rmode->fbWidth*VI_DISPLAY_PIX_SZ);

	VIDEO_Configure(rmode);
	VIDEO_SetNextFramebuffer(xfb);
	VIDEO_SetBlack(FALSE);
	VIDEO_Flush();
	VIDEO_WaitVSync();
	if(rmode->viTVMode&VI_NON_INTERLACE) VIDEO_WaitVSync();

    int volumen = 63;
	MODPlay_Init(&play);
	MODPlay_SetMOD(&play,technique_mod);
	MODPlay_SetVolume(&play,volumen,volumen);

	printf("\n\n");


	printf("Pulsa A para reproducir el audio MOD.\n");
	printf("Pulsa B para pausar el audio MOD. Vuelve a pulsarlo para reanudar.\n");

	while(1) {


		WPAD_ScanPads();


		u32 pressed = WPAD_ButtonsDown(0);

		if ( pressed & WPAD_BUTTON_HOME ) exit(0);

		if(pressed & WPAD_BUTTON_A) MODPlay_Start(&play);

        if(pressed & WPAD_BUTTON_PLUS){
            volumen++;
            MODPlay_SetVolume(&play,volumen, volumen);
        }
        if(pressed & WPAD_BUTTON_MINUS){
            volumen--;
            MODPlay_SetVolume(&play,volumen, volumen);
        }
		if(pressed & WPAD_BUTTON_B){
            if(ASND_Is_Paused()){
                ASND_Pause(0);
            }
            else{
                ASND_Pause(1);
            }
        }

		VIDEO_WaitVSync();
	}

	return 0;
}
