#include <stdio.h>
#include <stdlib.h>
#include <gccore.h>
#include <wiiuse/wpad.h>
#include <fat.h>
#include <asndlib.h>
#include <mp3player.h>
#include <wiisprite.h>
// include generated header
#include "amanecer_mp3.h"
using namespace wsp;


GameWindow gwd;
Sprite puntero;
Sprite animal1;
Sprite animal2;
Sprite animal3;
Sprite animal4;
Sprite fondo;
Sprite frontal;

Image imagen_puntero;
Image imagen1;
Image imagen2;
Image imagen3;
Image imagen4;
Image imagen_fondo;
Image imagen_frontal;
FILE *fp;

int inicio, ancho, alto;
//funcion para el lector del fichero mp3
s32  lector(void *f,void *dat, s32 size)
{
	return fread(dat, 1, size,(FILE*)f);
}
//---------------------------------------------------------------------------------
int main(int argc, char **argv) {
//---------------------------------------------------------------------------------

	fatInitDefault();
	WPAD_Init();
	gwd.InitVideo();

	ancho=gwd.GetWidth(); alto=gwd.GetHeight();
	ASND_Init();

	MP3Player_Init();

	inicio=1;

    LayerManager manager(7);

	if(imagen_puntero.LoadImage("cursor.png") != IMG_LOAD_ERROR_NONE)exit(0);
	if(imagen1.LoadImage("animal1.png") != IMG_LOAD_ERROR_NONE)exit(0);
	if(imagen2.LoadImage("animal2.png") != IMG_LOAD_ERROR_NONE)exit(0);
	if(imagen3.LoadImage("animal3.png") != IMG_LOAD_ERROR_NONE)exit(0);
	if(imagen4.LoadImage("animal4.png") != IMG_LOAD_ERROR_NONE)exit(0);
	if(imagen_fondo.LoadImage("fondo.png") != IMG_LOAD_ERROR_NONE)exit(0);
	if(imagen_frontal.LoadImage("frontal.png") != IMG_LOAD_ERROR_NONE)exit(0);

	puntero.SetImage(&imagen_puntero);
	animal1.SetImage(&imagen1);
	animal2.SetImage(&imagen2);
	animal3.SetImage(&imagen3);
	animal4.SetImage(&imagen4);
	fondo.SetImage(&imagen_fondo);
	frontal.SetImage(&imagen_frontal);



	puntero.SetPosition(0,0);

	frontal.SetPosition((ancho/2)-(frontal.GetWidth()/2), (alto/2)-(frontal.GetHeight()/2));

    animal1.SetPosition((ancho/3)-(animal1.GetWidth()/2), (alto/3)-(animal1.GetHeight()/2));
	animal2.SetPosition(((ancho/3)*2)-(animal2.GetWidth()/2), (alto/3)-(animal2.GetHeight()/2));
	animal3.SetPosition((ancho/3)-(animal3.GetWidth()/2), ((alto/3)*2)-(animal3.GetHeight()/2));
	animal4.SetPosition(((ancho/3)*2)-(animal4.GetWidth()/2), ((alto/3)*2)-(animal4.GetHeight()/2));

	fondo.SetRefPixelPositioning(REFPIXEL_POS_PIXEL);
	fondo.SetPosition(ancho/2, alto/2);

	manager.Append(&puntero);
	manager.Append(&frontal);
	manager.Append(&animal1);
	manager.Append(&animal2);
	manager.Append(&animal3);
	manager.Append(&animal4);
	manager.Append(&fondo);

	WPAD_SetDataFormat(WPAD_CHAN_0, WPAD_FMT_BTNS_ACC_IR);



    MP3Player_PlayBuffer(amanecer_mp3, amanecer_mp3_size, NULL);//se reproduce desde buffer la musica inicial

	ir_t ir;

	while(1) {


		WPAD_ScanPads();


		u32 pressed = WPAD_ButtonsDown(0);
		u32 held = WPAD_ButtonsHeld(0);


		if ( pressed & WPAD_BUTTON_HOME ) break;

		WPAD_IR(WPAD_CHAN_0, &ir);
		puntero.SetPosition(ir.sx-WSP_POINTER_CORRECTION_X, ir.sy-WSP_POINTER_CORRECTION_Y);
		puntero.Move(-((f32)puntero.GetWidth()/2), -((f32)puntero.GetHeight()/2));
		puntero.SetRotation(ir.angle/2);
//primero aparece la imagen frontal, al pulsar A, desaparece
        if(inicio==1){
		if(pressed & WPAD_BUTTON_A){
		    MP3Player_Stop();//se detiene la msica inicial
		    fclose(fp);
		    inicio=0;
		    manager.Remove(&frontal);//la imagen frontal desaparece
		}
        }
        if(inicio==0){
        if(puntero.CollidesWith(&animal1)){
            if( pressed & WPAD_BUTTON_A){
                MP3Player_Stop();//Se detiene cualquier sonido mp3 en reproduccion
                fclose(fp);
                fp=fopen("vaca.mp3","r");//se reproduce el sonido del animal correspondiente
                MP3Player_PlayFile(fp, lector, NULL);
            }
            if(held & WPAD_BUTTON_B){//pulsando B, arrastramos el sprite del animal
                animal1.SetPosition(puntero.GetX()-(animal1.GetWidth()/2), puntero.GetY()-(animal1.GetWidth()/2));
                animal1.SetRotation(ir.angle/2);
            }
		}
		else
        if(puntero.CollidesWith(&animal2)){
            if(pressed & WPAD_BUTTON_A){
                MP3Player_Stop();
                fclose(fp);
                fp=fopen("oveja.mp3","r");
                MP3Player_PlayFile(fp, lector, NULL);
            }
            if(held & WPAD_BUTTON_B){
                animal2.SetPosition(puntero.GetX()-(animal2.GetWidth()/2), puntero.GetY()-(animal2.GetWidth()/2));
                animal2.SetRotation(ir.angle/2);
            }
		} else
		if(puntero.CollidesWith(&animal3)){
            if(pressed & WPAD_BUTTON_A){
                MP3Player_Stop();
                fclose(fp);
                fp=fopen("cerdo.mp3","r");
                MP3Player_PlayFile(fp, lector, NULL);
            }
            if(held & WPAD_BUTTON_B){
                animal3.SetPosition(puntero.GetX()-(animal3.GetWidth()/2), puntero.GetY()-(animal3.GetWidth()/2));
                animal3.SetRotation(ir.angle/2);
            }
		} else
		if(puntero.CollidesWith(&animal4)){
            if(pressed & WPAD_BUTTON_A){
		    MP3Player_Stop();
		    fclose(fp);
            fp=fopen("perro.mp3","r");
            MP3Player_PlayFile(fp, lector, NULL);
            }
            if(held & WPAD_BUTTON_B){
                animal4.SetPosition(puntero.GetX()-(animal4.GetWidth()/2), puntero.GetY()-(animal4.GetWidth()/2));
                animal4.SetRotation(ir.angle/2);
            }
		}



        }




		manager.Draw(0,0);
		gwd.Flush();
	}

	MP3Player_Stop();
    fclose(fp);
    gwd.StopVideo();
    WPAD_Shutdown();



	return 0;
}

